unit FrameEingabe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, StdCtrls, Buttons;

type

  { TEingabeFrame }

  TEingabeFrame = class(TFrame)
    EdtNum: TEdit;
    kbBackslash: TSpeedButton;
    kbBS: TSpeedButton;
    kbDot: TSpeedButton;
    kbEnter: TSpeedButton;
    kbESC: TSpeedButton;
    kbLeft: TSpeedButton;
    kbRight: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton3: TSpeedButton;
    procedure SimpleKeyClick(Sender: TObject);
    procedure SpecialKeyClick(Sender: TObject);
  private
    FOnFertig, FOnExit: TNotifyEvent;
    OldValue : string;
    function GetValue: string;
    function GetWert: String;
    procedure PressVirtKey(p: LongInt);
    procedure SetOnExit(AValue: TNotifyEvent);
    procedure SetOnFertig(AValue: TNotifyEvent);
    procedure SetValue(AValue: string);
    procedure SetWert(AValue: String);
  public
    procedure SetFocusEingabe;
     property Value: string read GetValue write SetValue;
     property OnFertig: TNotifyEvent read FOnFertig write SetOnFertig;
     property OnExit: TNotifyEvent read FOnExit write SetOnExit;
     property Wert: String read GetWert write SetWert;
  end;

implementation

{$R *.lfm}
uses
  mouseandKeyinput, LCLType;

{ TEingabeFrame }

procedure TEingabeFrame.SimpleKeyClick(Sender: TObject);
begin
  Application.QueueAsyncCall(@PressVirtKey,ord(TSpeedButton(Sender).Caption[1]));
end;

procedure TEingabeFrame.SpecialKeyClick(Sender: TObject);
var
  k:word;
begin
//  if ActiveControl = nil then exit;
  if sender = kbEnter then
  begin
    if Assigned(FOnFertig) then
      FOnFertig(Sender);
    exit;
  end
  else if sender = kbESC then begin
    EdtNum.Text:= OldValue;
    if Assigned(FOnExit) then
      FOnExit(Sender);
    exit;
  end;
  if sender = kbLeft then k := VK_LEFT
  else if sender = kbRight then k := VK_RIGHT
  else if sender = kbBS then k := VK_BACK
  else if sender = kbDot then k := VK_DECIMAL
  else if sender = kbBackslash then k := VK_LCL_BACKSLASH
  else exit;
  Application.QueueAsyncCall(@PressVirtKey,k);
end;

function TEingabeFrame.GetValue: string;
begin
  Result := EdtNum.Text;
end;

function TEingabeFrame.GetWert: String;
begin
  Result := EdtNum.Text;
end;

procedure TEingabeFrame.PressVirtKey(p: LongInt);
begin
  KeyInput.Down(p);
  KeyInput.Up(p);
end;

procedure TEingabeFrame.SetOnExit(AValue: TNotifyEvent);
begin
  if FOnExit=AValue then Exit;
  FOnExit:=AValue;
end;

procedure TEingabeFrame.SetOnFertig(AValue: TNotifyEvent);
begin
  if FOnFertig=AValue then Exit;
  FOnFertig:=AValue;
end;

procedure TEingabeFrame.SetValue(AValue: string);
begin
  EdtNum.Text:= AValue;
end;

procedure TEingabeFrame.SetWert(AValue: String);
begin
  EdtNum.Text:= AValue;
end;

procedure TEingabeFrame.SetFocusEingabe;
begin
//  ActiveControl := EdtNum;
end;


end.

